/*******************************************************************************
* File Name: ADC_INT.c
* Version 3.10
*
* Description:
*  This file contains the code that operates during the ADC_DelSig interrupt
*  service routine.
*
* Note:
*
********************************************************************************
* Copyright 2008-2013, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "ADC.h"


/*******************************************************************************
* Custom Declarations and Variables
* - add user include files, prototypes and variables between the following
*   #START and #END tags
*******************************************************************************/
/* `#START ADC_SYS_VAR`  */
#include "Filter_PVT.h"
#include "VDAC.h"
extern int AdcPeak;
//extern  unsigned char VDAC_Data;
extern int32 FilterOutputM, filtero;
uint16 FilterOutput, FilterInput;
int16	rxRaw, IDCOffset=5000;		// must be signed int
uint8 HByte;
int32 Filter1;//war int16
long filterlong=0;
extern float coeff,coeffL, coeffH ;// Ergebniswerte der Goertzel- Filter
extern float Q0,Q1,Q2,P1,P2,R1,R2,filteri;
//extern uint16 FilterOutput, FilterInput;
extern unsigned char Counter, Counter2, Flag, Flag3;
extern int nn;// 250

// Goertzel- Koeffizient für 50 Schritte :
//extern float coeff, coeffL, coeffH;// cos( 2 * Pi * (800 Hz/8000 Hz))

/* `#END`  */


#if(ADC_IRQ_REMOVE == 0u)


    /*****************************************************************************
    * Function Name: ADC_ISR1
    ******************************************************************************
    *
    * Summary:
    *  Handle Interrupt Service Routine.
    *
    * Parameters:
    *  None
    *
    * Return:
    *  None
    *
    * Reentrant:
    *  No
    *
    *****************************************************************************/
    CY_ISR( ADC_ISR1)
    {
        /**************************************************************************
        *  Custom Code
        *  - add user ISR code between the following #START and #END tags
        **************************************************************************/
        /* `#START MAIN_ADC_ISR1`  */

//	ADC Interrupt Verarbeitung
//	Interrupts every 125 usec, 8000 sps
//----------------------------------------------------------------------------		
		// read ADC, subtract out DC offset, and multiply by gain
        rxRaw = ADC_GetResult16()- IDCOffset;;// 
		IDCOffset += (rxRaw & 0x8000) ? -1 : 1;	// calc new DC offset
	//	rxRaw = rxRaw * AgcGain;
        rxRaw*=8;
        FilterInput=rxRaw;
		Filter_STAGEAM_REG = (uint8)(rxRaw);//Weitergabe an Filter A
        Filter_STAGEAH_REG = (uint8)(rxRaw >> 8);
		// Filter A Output zum DAC --> Mithörton
        // ..und zum Goertzel- Filtert
        HByte=Filter_HOLDAH_REG;
        //VDAC_SetValue((uint8)(rxRaw>>8)^0x80);// Testausgabe
        VDAC_SetValue(HByte^0x80);// geht zum NF- Output
	    FilterOutput = Filter_HOLDAM_REG;
        FilterOutput |= (uint16)((HByte^0x80) << 8);
		;// +++++++++ ++++++++ weiter zur Signalbewertung und zu den Goertzel- Filtern:
     
        Filter1=FilterOutput-0x7fff;;//von uint16 nach int16
        if(Filter1<0) Filter1=-Filter1;// Vollwellen- Gleichrichter
        
        if (Filter1 > FilterOutputM)// mitlaufender Anstieg
		    FilterOutputM = Filter1;
        else 
            if(FilterOutputM>400) FilterOutputM= FilterOutputM-400;//linearer Abfall
        filtero=FilterOutputM;// Auswertung in main / GetSignal()
        filteri=(float) FilterOutput;
       
        Q0 = coeff * Q1 - Q2 + filteri;// 800 Hz 
        Q2 = Q1;
        Q1 = Q0;
        if(Counter2&1){
        Q0 = coeffL * P1 - P2 +  filteri;// 750 Hz 
        P2 = P1;
        P1 = Q0;
        } else {
        Q0 = coeffH * R1 - R2 +  filteri;// 850 Hz 
        R2 = R1;
        R1 = Q0;
        }
        if(++Counter==nn) {// 250 Schritte
            Counter=0;
            Flag=1;// neue Goertzel- Daten melden
            
        }
        ++Counter2;
        Flag3=1;
        
        /* `#END`  */

        /* Stop the conversion if conversion mode is single sample and resolution
        *  is above 16 bits.
        */
        #if(ADC_CFG1_RESOLUTION > 16 && \
            ADC_CFG1_CONV_MODE == ADC_MODE_SINGLE_SAMPLE)
            ADC_StopConvert();
            /* Software flag for checking conversion complete or not. Will be used when
            *  resolution is above 16 bits and conversion mode is single sample 
			*/
            ADC_convDone = ADC_DEC_CONV_DONE;
        #endif /* Single sample conversion mode with resolution above 16 bits */

    }


    /*****************************************************************************
    * Function Name: ADC_ISR2
    ******************************************************************************
    *
    * Summary:
    *  Handle Interrupt Service Routine.
    *
    * Parameters:
    *  None
    *
    * Return:
    *  None
    *
    * Reentrant:
    *  No
    *
    *****************************************************************************/
    CY_ISR( ADC_ISR2)
    {
        /***************************************************************************
        *  Custom Code
        *  - add user ISR code between the following #START and #END tags
        **************************************************************************/
        /* `#START MAIN_ADC_ISR2`  */

        /* `#END`  */

        /* Stop the conversion conversion mode is single sample and resolution
        *  is above 16 bits.
        */
        #if(ADC_CFG2_RESOLUTION > 16 && \
            ADC_CFG2_CONVMODE == ADC_MODE_SINGLE_SAMPLE)
            ADC_StopConvert();
            /* Software flag for checking conversion complete or not. Will be used when
            *   resolution is above 16 bits and conversion mode is single sample 
			*/
            ADC_convDone = ADC_DEC_CONV_DONE;
        #endif /* Single sample conversion mode with resolution above 16 bits */

    }


    /*****************************************************************************
    * Function Name: ADC_ISR3
    ******************************************************************************
    *
    * Summary:
    *  Handle Interrupt Service Routine.
    *
    * Parameters:
    *  None
    *
    * Return:
    *  None
    *
    * Reentrant:
    *  No
    *
    *****************************************************************************/
    CY_ISR( ADC_ISR3)
    {
        /***************************************************************************
        *  Custom Code
        *  - add user ISR code between the following #START and #END tags
        **************************************************************************/
        /* `#START MAIN_ADC_ISR3`  */

        /* `#END`  */

        /* Stop the conversion if conversion mode is set to single sample and
        *  resolution is above 16 bits.
        */
        #if(ADC_CFG3_RESOLUTION > 16 && \
            ADC_CFG3_CONVMODE == ADC_MODE_SINGLE_SAMPLE)
            ADC_StopConvert();
            /* Software flag for checking conversion complete or not. Will be used when
            *  resolution is above 16 bits and conversion mode is single sample 
			*/
            ADC_convDone = ADC_DEC_CONV_DONE;
        #endif /* Single sample conversion mode with resolution above 16 bits */
    }


    /*****************************************************************************
    * Function Name: ADC_ISR4
    ******************************************************************************
    *
    * Summary:
    *  Handle Interrupt Service Routine.
    *
    * Parameters:
    *  None
    *
    * Return:
    *  None
    *
    * Reentrant:
    *  No
    *
    *****************************************************************************/
    CY_ISR( ADC_ISR4)
    {
        /***************************************************************************
        *  Custom Code
        *  - add user ISR code between the following #START and #END tags
        **************************************************************************/
        /* `#START MAIN_ADC_ISR4`  */

        /* `#END`  */

        /* Stop the conversion if conversion mode is set to single sample and
        *  resolution is above 16 bits.
        */
        #if(ADC_CFG4_RESOLUTION > 16 && \
            ADC_CFG4_CONVMODE == ADC_MODE_SINGLE_SAMPLE)
            ADC_StopConvert();
            /* Software flag for checking conversion complete or not. Will be used when
            *  resolution is above 16 bits and conversion mode is single sample 
			*/
            ADC_convDone = ADC_DEC_CONV_DONE;
        #endif /* Single sample conversion mode with resolution above 16 bits */
    }

#endif   /* End ADC_IRQ_REMOVE */


/* [] END OF FILE */
