/*******************************************************************************
* File Name: Clk48.h  
* Version 2.5
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Clk48_H) /* Pins Clk48_H */
#define CY_PINS_Clk48_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Clk48_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Clk48_Write(uint8 value) ;
void    Clk48_SetDriveMode(uint8 mode) ;
uint8   Clk48_ReadDataReg(void) ;
uint8   Clk48_Read(void) ;
uint8   Clk48_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Clk48_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Clk48_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Clk48_DM_RES_UP          PIN_DM_RES_UP
#define Clk48_DM_RES_DWN         PIN_DM_RES_DWN
#define Clk48_DM_OD_LO           PIN_DM_OD_LO
#define Clk48_DM_OD_HI           PIN_DM_OD_HI
#define Clk48_DM_STRONG          PIN_DM_STRONG
#define Clk48_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Clk48_MASK               Clk48__MASK
#define Clk48_SHIFT              Clk48__SHIFT
#define Clk48_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Clk48_PS                     (* (reg8 *) Clk48__PS)
/* Data Register */
#define Clk48_DR                     (* (reg8 *) Clk48__DR)
/* Port Number */
#define Clk48_PRT_NUM                (* (reg8 *) Clk48__PRT) 
/* Connect to Analog Globals */                                                  
#define Clk48_AG                     (* (reg8 *) Clk48__AG)                       
/* Analog MUX bux enable */
#define Clk48_AMUX                   (* (reg8 *) Clk48__AMUX) 
/* Bidirectional Enable */                                                        
#define Clk48_BIE                    (* (reg8 *) Clk48__BIE)
/* Bit-mask for Aliased Register Access */
#define Clk48_BIT_MASK               (* (reg8 *) Clk48__BIT_MASK)
/* Bypass Enable */
#define Clk48_BYP                    (* (reg8 *) Clk48__BYP)
/* Port wide control signals */                                                   
#define Clk48_CTL                    (* (reg8 *) Clk48__CTL)
/* Drive Modes */
#define Clk48_DM0                    (* (reg8 *) Clk48__DM0) 
#define Clk48_DM1                    (* (reg8 *) Clk48__DM1)
#define Clk48_DM2                    (* (reg8 *) Clk48__DM2) 
/* Input Buffer Disable Override */
#define Clk48_INP_DIS                (* (reg8 *) Clk48__INP_DIS)
/* LCD Common or Segment Drive */
#define Clk48_LCD_COM_SEG            (* (reg8 *) Clk48__LCD_COM_SEG)
/* Enable Segment LCD */
#define Clk48_LCD_EN                 (* (reg8 *) Clk48__LCD_EN)
/* Slew Rate Control */
#define Clk48_SLW                    (* (reg8 *) Clk48__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Clk48_PRTDSI__CAPS_SEL       (* (reg8 *) Clk48__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Clk48_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Clk48__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Clk48_PRTDSI__OE_SEL0        (* (reg8 *) Clk48__PRTDSI__OE_SEL0) 
#define Clk48_PRTDSI__OE_SEL1        (* (reg8 *) Clk48__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Clk48_PRTDSI__OUT_SEL0       (* (reg8 *) Clk48__PRTDSI__OUT_SEL0) 
#define Clk48_PRTDSI__OUT_SEL1       (* (reg8 *) Clk48__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Clk48_PRTDSI__SYNC_OUT       (* (reg8 *) Clk48__PRTDSI__SYNC_OUT) 


#if defined(Clk48__INTSTAT)  /* Interrupt Registers */

    #define Clk48_INTSTAT                (* (reg8 *) Clk48__INTSTAT)
    #define Clk48_SNAP                   (* (reg8 *) Clk48__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Clk48_H */


/* [] END OF FILE */
