/*******************************************************************************
* File Name: Rotary_Encoder1.c  
* Version 2.5
*
* Description:
*  This file contains API to enable firmware control of a Pins component.
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#include "cytypes.h"
#include "Rotary_Encoder1.h"


/*******************************************************************************
* Function Name: Rotary_Encoder1_Write
********************************************************************************
*
* Summary:
*  Assign a new value to the digital port's data output register.  
*
* Parameters:  
*  prtValue:  The value to be assigned to the Digital Port. 
*
* Return: 
*  None 
*  
*******************************************************************************/
void Rotary_Encoder1_Write(uint8 value) 
{
    uint8 staticBits = (Rotary_Encoder1_DR & (uint8)(~Rotary_Encoder1_MASK));
    Rotary_Encoder1_DR = staticBits | ((uint8)(value << Rotary_Encoder1_SHIFT) & Rotary_Encoder1_MASK);
}


/*******************************************************************************
* Function Name: Rotary_Encoder1_SetDriveMode
********************************************************************************
*
* Summary:
*  Change the drive mode on the pins of the port.
* 
* Parameters:  
*  mode:  Change the pins to one of the following drive modes.
*
*  Rotary_Encoder1_DM_STRONG     Strong Drive 
*  Rotary_Encoder1_DM_OD_HI      Open Drain, Drives High 
*  Rotary_Encoder1_DM_OD_LO      Open Drain, Drives Low 
*  Rotary_Encoder1_DM_RES_UP     Resistive Pull Up 
*  Rotary_Encoder1_DM_RES_DWN    Resistive Pull Down 
*  Rotary_Encoder1_DM_RES_UPDWN  Resistive Pull Up/Down 
*  Rotary_Encoder1_DM_DIG_HIZ    High Impedance Digital 
*  Rotary_Encoder1_DM_ALG_HIZ    High Impedance Analog 
*
* Return: 
*  None
*
*******************************************************************************/
void Rotary_Encoder1_SetDriveMode(uint8 mode) 
{
	CyPins_SetPinDriveMode(Rotary_Encoder1_0, mode);
}


/*******************************************************************************
* Function Name: Rotary_Encoder1_Read
********************************************************************************
*
* Summary:
*  Read the current value on the pins of the Digital Port in right justified 
*  form.
*
* Parameters:  
*  None 
*
* Return: 
*  Returns the current value of the Digital Port as a right justified number
*  
* Note:
*  Macro Rotary_Encoder1_ReadPS calls this function. 
*  
*******************************************************************************/
uint8 Rotary_Encoder1_Read(void) 
{
    return (Rotary_Encoder1_PS & Rotary_Encoder1_MASK) >> Rotary_Encoder1_SHIFT;
}


/*******************************************************************************
* Function Name: Rotary_Encoder1_ReadDataReg
********************************************************************************
*
* Summary:
*  Read the current value assigned to a Digital Port's data output register
*
* Parameters:  
*  None 
*
* Return: 
*  Returns the current value assigned to the Digital Port's data output register
*  
*******************************************************************************/
uint8 Rotary_Encoder1_ReadDataReg(void) 
{
    return (Rotary_Encoder1_DR & Rotary_Encoder1_MASK) >> Rotary_Encoder1_SHIFT;
}


/* If Interrupts Are Enabled for this Pins component */ 
#if defined(Rotary_Encoder1_INTSTAT) 

    /*******************************************************************************
    * Function Name: Rotary_Encoder1_ClearInterrupt
    ********************************************************************************
    *
    * Summary:
    *  Clears any active interrupts attached to port and returns the value of the 
    *  interrupt status register.
    *
    * Parameters:  
    *  None 
    *
    * Return: 
    *  Returns the value of the interrupt status register
    *  
    *******************************************************************************/
    uint8 Rotary_Encoder1_ClearInterrupt(void) 
    {
        return (Rotary_Encoder1_INTSTAT & Rotary_Encoder1_MASK) >> Rotary_Encoder1_SHIFT;
    }

#endif /* If Interrupts Are Enabled for this Pins component */ 


/* [] END OF FILE */
