/*******************************************************************************
* File Name: Rotary_Encoder2.h  
* Version 2.5
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Rotary_Encoder2_H) /* Pins Rotary_Encoder2_H */
#define CY_PINS_Rotary_Encoder2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Rotary_Encoder2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Rotary_Encoder2_Write(uint8 value) ;
void    Rotary_Encoder2_SetDriveMode(uint8 mode) ;
uint8   Rotary_Encoder2_ReadDataReg(void) ;
uint8   Rotary_Encoder2_Read(void) ;
uint8   Rotary_Encoder2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Rotary_Encoder2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Rotary_Encoder2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Rotary_Encoder2_DM_RES_UP          PIN_DM_RES_UP
#define Rotary_Encoder2_DM_RES_DWN         PIN_DM_RES_DWN
#define Rotary_Encoder2_DM_OD_LO           PIN_DM_OD_LO
#define Rotary_Encoder2_DM_OD_HI           PIN_DM_OD_HI
#define Rotary_Encoder2_DM_STRONG          PIN_DM_STRONG
#define Rotary_Encoder2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Rotary_Encoder2_MASK               Rotary_Encoder2__MASK
#define Rotary_Encoder2_SHIFT              Rotary_Encoder2__SHIFT
#define Rotary_Encoder2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Rotary_Encoder2_PS                     (* (reg8 *) Rotary_Encoder2__PS)
/* Data Register */
#define Rotary_Encoder2_DR                     (* (reg8 *) Rotary_Encoder2__DR)
/* Port Number */
#define Rotary_Encoder2_PRT_NUM                (* (reg8 *) Rotary_Encoder2__PRT) 
/* Connect to Analog Globals */                                                  
#define Rotary_Encoder2_AG                     (* (reg8 *) Rotary_Encoder2__AG)                       
/* Analog MUX bux enable */
#define Rotary_Encoder2_AMUX                   (* (reg8 *) Rotary_Encoder2__AMUX) 
/* Bidirectional Enable */                                                        
#define Rotary_Encoder2_BIE                    (* (reg8 *) Rotary_Encoder2__BIE)
/* Bit-mask for Aliased Register Access */
#define Rotary_Encoder2_BIT_MASK               (* (reg8 *) Rotary_Encoder2__BIT_MASK)
/* Bypass Enable */
#define Rotary_Encoder2_BYP                    (* (reg8 *) Rotary_Encoder2__BYP)
/* Port wide control signals */                                                   
#define Rotary_Encoder2_CTL                    (* (reg8 *) Rotary_Encoder2__CTL)
/* Drive Modes */
#define Rotary_Encoder2_DM0                    (* (reg8 *) Rotary_Encoder2__DM0) 
#define Rotary_Encoder2_DM1                    (* (reg8 *) Rotary_Encoder2__DM1)
#define Rotary_Encoder2_DM2                    (* (reg8 *) Rotary_Encoder2__DM2) 
/* Input Buffer Disable Override */
#define Rotary_Encoder2_INP_DIS                (* (reg8 *) Rotary_Encoder2__INP_DIS)
/* LCD Common or Segment Drive */
#define Rotary_Encoder2_LCD_COM_SEG            (* (reg8 *) Rotary_Encoder2__LCD_COM_SEG)
/* Enable Segment LCD */
#define Rotary_Encoder2_LCD_EN                 (* (reg8 *) Rotary_Encoder2__LCD_EN)
/* Slew Rate Control */
#define Rotary_Encoder2_SLW                    (* (reg8 *) Rotary_Encoder2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Rotary_Encoder2_PRTDSI__CAPS_SEL       (* (reg8 *) Rotary_Encoder2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Rotary_Encoder2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Rotary_Encoder2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Rotary_Encoder2_PRTDSI__OE_SEL0        (* (reg8 *) Rotary_Encoder2__PRTDSI__OE_SEL0) 
#define Rotary_Encoder2_PRTDSI__OE_SEL1        (* (reg8 *) Rotary_Encoder2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Rotary_Encoder2_PRTDSI__OUT_SEL0       (* (reg8 *) Rotary_Encoder2__PRTDSI__OUT_SEL0) 
#define Rotary_Encoder2_PRTDSI__OUT_SEL1       (* (reg8 *) Rotary_Encoder2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Rotary_Encoder2_PRTDSI__SYNC_OUT       (* (reg8 *) Rotary_Encoder2__PRTDSI__SYNC_OUT) 


#if defined(Rotary_Encoder2__INTSTAT)  /* Interrupt Registers */

    #define Rotary_Encoder2_INTSTAT                (* (reg8 *) Rotary_Encoder2__INTSTAT)
    #define Rotary_Encoder2_SNAP                   (* (reg8 *) Rotary_Encoder2__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Rotary_Encoder2_H */


/* [] END OF FILE */
