/*******************************************************************************
* File Name: ADC_INT.c  
* Version 2.30
*
* Description:
*  This file contains the code that operates during the ADC_DelSig interrupt 
*  service routine.  
*
* Note:
*
*******************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include "ADC.h"  


/*******************************************************************************
* Custom Declarations and Variables
* - add user inlcude files, prototypes and variables between the following 
*   #START and #END tags
*******************************************************************************/
/* `#START ADC_SYS_VAR`  */
#include "Filter_PVT.h"
#include "VDAC.h"
extern int AdcPeak;
// Goertzel- Koeffizient für 50 Schritte :
extern float coeff, coeffL, coeffH;// cos( 2 * Pi * (800 Hz/8000 Hz))
//extern  unsigned char VDAC_Data;
extern int nn;// 50
extern unsigned char Counter;
extern float GoertzelM, GoertzelH, GoertzelL;// Ergebniswerte der Goertzel- Filter
float Q0,Q1=0,Q2=0,P1=0,P2=0,R1=0,R2=0;
int16	rxRaw, IDCOffset=0;		// must be signed int
uint8 HByte;
uint16 FilterOutput;

/* `#END`  */


/*****************************************************************************
* Function Name: ADC_ISR1
******************************************************************************
*
* Summary:
*  Handle Interrupt Service Routine.  
*
* Parameters:  
*  void
*
* Return: 
*  void 
*
* Reentrant: 
*  No
*
*****************************************************************************/
CY_ISR( ADC_ISR1)
{
    /***************************************************************************
    *  Custom Code
    *  - add user ISR code between the following #START and #END tags
    **************************************************************************/
    /* `#START MAIN_ADC_ISR1`  */

//	ADC Interrupt Verarbeitung
//	Interrupts every 125 usec, 8000 sps
//----------------------------------------------------------------------------		
		// read ADC, subtract out DC offset, and multiply by gain
	//	ADC_StopConvert();// ***
        rxRaw = ADC_GetResult16()- IDCOffset;;// 
		IDCOffset += (rxRaw & 0x8000) ? -1 : 1;	// calc new DC offset
	//	rxRaw = rxRaw * AgcGain;
     //   ADC_StartConvert();// ***
		Filter_STAGEAM_REG = (uint8)(rxRaw);//Weitergabe an Filter A
        Filter_STAGEAH_REG = (uint8)(rxRaw >> 8);
		// Filter A Output zum DAC
        // ..und zum Goertzel- Filtert
        HByte=Filter_HOLDAH_REG;
        VDAC_SetValue((uint8)(rxRaw>>8)^0x80);// Testausgabe
       // VDAC_SetValue(HByte ^ 0x80);// geht zum NF- Output
	    FilterOutput = Filter_HOLDAM_REG;
        FilterOutput |= (uint16)((HByte) << 8);
		;// +++++++++ ++++++++ weiter zu den Goertzel- Filtern:
        Q0 = coeff * Q1 - Q2 + (float) FilterOutput;// 800 Hz 
        Q2 = Q1;
        Q1 = Q0;
     /*   Q0 = coeffL * P1 - P2 + (float) FilterOutput;// 770 Hz 
        P2 = P1;
        P1 = Q0;
        Q0 = coeffH * R1 - R2 + (float) FilterOutput;// 830 Hz 
        R2 = R1;
        R1 = Q0;*/
        if(Counter>=nn) {// 50 steps
            Counter=0;//  >> mainroutine
            GoertzelM=(Q1*Q1)+(Q2*Q2)-Q1*Q2*coeff;//Quadrat der Magnitude
            Q1=Q2=0;
     /*       GoertzelL=(P1*P1)+(P2*P2)-P1*P2*coeffL;
            P1=P2=0;
            GoertzelH=(R1*R1)+(R2*R2)-R1*R2*coeffH;
            R1=R2=0;*/
        }              
	
//	if (rxRaw > AdcPeak)
//		AdcPeak = rxRaw;
	
    /* `#END`  */
    
    /* Stop the conversion if conversion mode is single sample and resolution
       is above 16 bits. 
    */
    #if(ADC_CFG1_RESOLUTION > 16 && \
        ADC_CFG1_CONV_MODE == ADC_MODE_SINGLE_SAMPLE) 
        ADC_StopConvert(); 
    #endif /* Single sample conversion mode with resolution above 16 bits */         
        
}


/*****************************************************************************
* Function Name: ADC_ISR2
******************************************************************************
*
* Summary:
*  Handle Interrupt Service Routine.  
*
* Parameters:  
*  void
*
* Return: 
*  void 
*
* Reentrant: 
*  No
*
*****************************************************************************/
CY_ISR( ADC_ISR2)
{
    /***************************************************************************
    *  Custom Code
    *  - add user ISR code between the following #START and #END tags
    **************************************************************************/
    /* `#START MAIN_ADC_ISR2`  */

    /* `#END`  */
    
    /* Stop the conversion conversion mode is single sample and resolution
       is above 16 bits.
    */
    #if(ADC_CFG2_RESOLUTION > 16 && \
        ADC_CFG2_CONVMODE == ADC_MODE_SINGLE_SAMPLE) 
        ADC_StopConvert(); 
    #endif /* Single sample conversion mode with resolution above 16 bits */
    
}


/*****************************************************************************
* Function Name: ADC_ISR3
******************************************************************************
*
* Summary:
*  Handle Interrupt Service Routine.  
*
* Parameters:  
*  void
*
* Return: 
*  void 
*
* Reentrant: 
*  No
*
*****************************************************************************/
CY_ISR( ADC_ISR3)
{
    /***************************************************************************
    *  Custom Code
    *  - add user ISR code between the following #START and #END tags
    **************************************************************************/
    /* `#START MAIN_ADC_ISR3`  */

    /* `#END`  */

    /* Stop the conversion if conversion mode is set to single sample and 
       resolution is above 16 bits. 
    */
    #if(ADC_CFG3_RESOLUTION > 16 && \
        ADC_CFG3_CONVMODE == ADC_MODE_SINGLE_SAMPLE) 
        ADC_StopConvert(); 
    #endif /* Single sample conversion mode with resolution above 16 bits */  
}


/*****************************************************************************
* Function Name: ADC_ISR4
******************************************************************************
*
* Summary:
*  Handle Interrupt Service Routine.  
*
* Parameters:  
*  void
*
* Return: 
*  void 
*
* Reentrant: 
*  No
*
*****************************************************************************/
CY_ISR( ADC_ISR4)
{
    /***************************************************************************
    *  Custom Code
    *  - add user ISR code between the following #START and #END tags
    **************************************************************************/
    /* `#START MAIN_ADC_ISR4`  */

    /* `#END`  */
    
    /* Stop the conversion if conversion mode is set to single sample and 
       resolution is above 16 bits. 
    */
    #if(ADC_CFG4_RESOLUTION > 16 && \
        ADC_CFG4_CONVMODE == ADC_MODE_SINGLE_SAMPLE) 
        ADC_StopConvert(); 
    #endif /* Single sample conversion mode with resolution above 16 bits */
}


/* [] END OF FILE */
