/* ========================================
 * Morse 0.1
 
 * Wolfgang Kiefer, DH1AKF
 * ========================================
*/
#include <device.h>
#include "math.h"
#include "stdio.h"

#define PI 3.14159

///////////////////////////////////////////////////////////////////////
// CW Decoder made by Hjalmar Skovholm Hansen OZ1JHM  VER 1.01       //
// Feel free to change, copy or what ever you like but respect       //
// that license is http://www.gnu.org/copyleft/gpl.html              //
// Discuss and give great ideas on                                   //
// https://groups.yahoo.com/neo/groups/oz1jhm/conversations/messages //
///////////////////////////////////////////////////////////////////////
/* Überarbeitet und weiterentwickelt von W.Kiefer (DH1AKF) Okt. 2014 
   übertragen auf PSoC5: Jan. 2015 */
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////
//;// 16;//20; /// have to be 16 or 20

#define rows    4
#define maxMenu     1
/* Variablen/Definitionen für den Morsedecoder*/
// Zeichenanzahl des Displays:
#define LCDCount 80
// Länge einer Zeile:
#define colums  20
// Endeerkennung: ca. 1 Sekunde
#define tmax	1000

//	
//static
	
const  unsigned char CODETAB[256]={
	0xf1,' ','E','T','I','A','N','M','S','U','R','W','D','K','G','O','H','V','F',3,
	'L',1,'P','J','B','X','C','Y','Z','Q',2,0xf2,'5','4',0xf3,'3','*','*','*','2',
	'*','*','+','*','*','*','*','1','6','=','/','*','*','*','(','*','7','*','*','*',
	'8','*','9','0','*','*','*','*','*',0xf4,'*','*','*','*','*','*','?','_','*','*',
	'*','*','*','*','*','.','*','*','*','*','@','*','*','*',0x27,'*','*','-','*','*',
	'*','*','*','*','*','*',';','*','*',')','*','*','*','*','*',',','*','*','*','*',
	':','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
	0xf5,'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
	'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
	'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
	'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
	'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
	'*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*'};
const unsigned char SUBTAB[12]={' ',' ','i','i','C','H','V','E','S','K','S','S'};


int lcdindex = 0;
int line1[colums];
int line2[colums];
int mode=0;// Anzeigemodus (Menü)
// 0: nach OZ1JHM  1: DH1AKF
int key;
 float avg;
 int umin=512;
 int umax=0;
 
 
unsigned long	korr;
unsigned long input_freq = 0;	
unsigned char ziffer;
unsigned long dez;
unsigned char index1,zei;
	char	sig;//0 oder 1 --> das Eingangssignal
	uint16	tsig; //gemessene Signaldauer eines Dit oder Daa
	uint16	tpaus;//Pause 
	uint16	tkrit;//Kriterium für Dit<->Daa
	uint16	chpaus;//Pause zwischen 2 Zeichen
	uint16	wpaus;//Pause zwischen 2 Worten
	//int	tprell;//Prellzeit
	uint16 mchar;//aktuelles Zeichen
	char prevstate = 0;
	int	err=0;// Fehler (Dauerton)
	char	we;//Wortende erreicht
	char	found;//Zeichenende gefunden
	char	start1;//erstes Dit/Daa und erste Pause auswerten
	uint16	Dit_Length;//gleitender Mittelwert
	uint16	Daalength;//gleitender Mittelwert
    uint16  DPaus;// Pause zwischen DITs bzw. DAAs
    uint16  ZPaus;// Pause zwischen Zeichen
	uint16	firstsig;//das erste Dit bzw. Daa
  //  uint16  bpm;
	
    //Codetabelle Morsezeichen:
	unsigned char	change,keypressed;
	unsigned char	i;
	unsigned char	pos;//Anzeigeposition
	unsigned char	k;
	unsigned char	Bpm;//speed
	char	displ[LCDCount-colums];
	char	cchar;//auszugebendes Zeichen
	char	phase;//zentrale Ablaufsteuerung
	char 	sign;//Signal da oder nicht da
	char	ende=0;
	int y;
	unsigned long time,timeold,diff,timerstart;
	//für Testzwecke:
	int	numm;
	int	zahl;
	int r,s,oldtick,oldsig;
	char	todo;
    int wpm;
    uint16  AdcState;
    uint8 AdcTick;
    long Tim30s=1;
    uint8 line=0;


int32 magnitude ;
int32 magnitudelimit = 800;
int32 magnitudelimit_low = 400;//10

int32 MagnQuer=800;
char realstate = 0;
char realstatebefore = 0;
char filteredstate = 0;
char filteredstatebefore = 0;

 
//////////////////////////////
// Noise Blanker time which //
// shall be computed so     //
// this is initial          //
//////////////////////////////
int nbtime = 6;  /// ms noise blanker         

long starttimehigh;
uint16 highduration;
long lowtimesavg;
long starttimelow;
uint16 lowduration;

char code1[20];
int stop = 1;//0;
int wpm;

float Q0,Q1=0,Q2=0,P1=0,P2=0,R1=0,R2=0,filteri;
int32 filtero, SigMax, SigMin;
int32 FilterOutputM=0;
//int32 Max=0;
int32 rc=0, rd=0;
char line0[10]={' ',' ',' ',' ',' ',' ',' ',' ',' ',0};

int counter1=0;
float  coeff, coeffM, coeffL, coeffH, coeffLS, coeffHS, coeffneu;
//float sine;
int  nn=80;//150 ; 250;  // Number of Samples - if you change it please change next line also 
unsigned char Counter=0;
unsigned char Counter2=2;// damit die Ergebnisse nicht gleichzeitig berechnet werden müssen
unsigned char Flag=0;// 1: neuer Wert vom Goertzel liegt vor
float GoertzelM, GoertzelH, GoertzelL;
int32 helpLQuer;
int32 helpHQuer;
int16 Htimes[80];// Speicher für die gemessenen Zeiten
int16 Ltimes[80];// Speicher für die gemessenen Zeiten
int16  Hpointer=0;
int16  Lpointer=0;
int16   thmax,thmin, thquer;// Signalzeiten
int16   tlmax,tlmin;// Pausenzeiten
int16   tlkrit;// Kriterium DPaus oder ZPaus
int16 tprell=9;//(Ent)Prellzeit --> max 600 Bpm
char8 count, Start, DataContr;
int16 ReadPointer;
//int16 StorePointer=0;
//int16 RestorePointer=0;
int16 indexMin=255;
char Flag1=0;
unsigned char Flag3=0;
unsigned char Zeichenspeicher[120];
char cLength;
uint8 noiseCounter=0;
int32 Msig=0;
int16 RelSig;
int16 Count3=0;
unsigned char StrengthCounter=0, StrengthCounter1=0, TimoCounter=0, DecodeFlag;

long millis(){//Zeitgeber 1 ms
    return 30000*Tim30s -Counter_MilliSek_ReadCounter();// Counter zählt abwärts !!
}

 
// ******************************************************************************************************* 

void ReInit(){
if(Dit_Length<12)
    Dit_Length=55;// 37; 55 bei 10wpm
if(thquer>Dit_Length) Dit_Length=thquer;
tkrit=2 * Dit_Length;
//chpaus=3 * Dit_Length;
//wpaus=7 * Dit_Length;

//we=prevstate=tsig=0;
count=0;
Hpointer=Lpointer=0;
thmax=tlmax=0;
thmin=tlmin=20000;// 20 sek
thquer=0;
Start=1;
stop=1;
mchar=1;//aktuelles Zeichen: Startbit gesetzt
cLength=0;//gelesene Dit's / DAA's
ReadPointer=0;
indexMin=255;
//filtero=2000;// Startwert
SigMax=0;
SigMin=50000;
StrengthCounter=0;
StrengthCounter1=0;
Msig=0;
} 
 
void ISR_0_5(void){  //Zeitüberwachung
    if((RelSig<12)&&(stop==0)) {
        noiseCounter++; // kein Signal da
        if(noiseCounter==10) {
            ReInit();
        }
        else if(noiseCounter==20) noiseCounter--;
    }
    else{
        noiseCounter=0;// TimeOut
        if(((DecodeFlag==0)||(Dit_Length<=11))){//Signal vorhanden, wird aber nicht decodiert
            TimoCounter++;
            if(TimoCounter>10) {// 2 Sekunden
                TimoCounter=0;
                ReInit();
            }
        }
    }
    DecodeFlag=0;   
}
    
void updateinfolinelcd(){
/////////////////////////////////////
// here we update the upper line   //
// with the speed.                 //
/////////////////////////////////////

/*  int place;
  if (rows == 4){
   place = colums/2;}
  else{
   place = 2;
  }
	if (wpm<10){
		LCD_Position((place)-2,0);
		LCD_PutChar('0');
		LCD_Position((place)-1,0);
		PrintChar(wpm);
		LCD_Position((place),0);
		LCD_PrintString(" WPM");
	}
	else{
		LCD_Position((place)-2,0);
		PrintChar(wpm);
		LCD_Position((place),0);
		LCD_PrintString(" WPM ");
	}*/
 } 

    
void	roll(){
char c;

if(pos>=20){// Zeile voll?
	pos=0;
    line++;
    if(line>3) {
       /* LCD_Position(1,0);
        for(c=0;c<colums;c++){
            LCD_PutChar(displ[c+colums]); //eine Zeile rollen
        }*/
        LCD_Position(2,0);        
        for(c=2*colums;c<3*colums;c++){
            LCD_PutChar(displ[c]); //eine Zeile rollen
        }
        LCD_Position(3,0);
        LCD_PrintString("                    ");
        line=3; 
	}
  }
}

/*
void StoreChar(unsigned char a){
    Zeichenspeicher[StorePointer++]=a;
    if(StorePointer>=120) StorePointer=0;
}

void RestoreChar(void){
if(StorePointer!=RestorePointer)
    CharOut(Zeichenspeicher[RestorePointer++]);
    if(RestorePointer>=120) RestorePointer=0;
}
*/

void CharOut(unsigned char uchar){
LCD_Position(line, pos);
LCD_PutChar(uchar);
displ[pos+colums*(line-1)]=uchar;// speichern
pos++;
roll();
}


void decode(){
unsigned char a;
  if(cLength>7) {// Fehler- zu langes Zeichen 
    cLength=0;
    CharOut('$');
    return;
   }
  if(noiseCounter>=3) return;
  DecodeFlag=1;
  //mchar=mchar&255;
  a=CODETAB[mchar];
  mchar=1;// Startwert für das nächste Zeichen
  cLength=0;
  if(a<0xf0)
    CharOut(a);
   else{
     a&=0xf;
     a=a<<1;
     CharOut(SUBTAB[a]);
     CharOut((unsigned char)SUBTAB[a+1]);
   }
}
 

void DIT(){
  
  cLength++;
  if(cLength>7) return;
  //if((Dit_Length<=5)&& (highduration<400)&&(highduration>10))Dit_Length=highduration;//Aktueller Wert wird Startwert
  mchar= mchar<<1;	
  if((Start==2)&&(highduration>16)) Dit_Length=Dit_Length-(Dit_Length>>4)+(highduration>>4);// gleitender Mittelwert 
}

void DAA(){
  cLength++;
  if(cLength>7) return; 
  mchar=mchar<<1;
  mchar++;
  
}


void StoreHigh(void){// Signaldauer speichern
 if(Hpointer<79){
    Htimes[Hpointer]=(int16)highduration;
    if(highduration>thmax) thmax=highduration;//Dauerton >2s ausschliessen (geschieht in main)
    else if((highduration<=thmin)&&(highduration>tprell)&&(highduration<thmax/2)) {
        if(indexMin!=255){
            Dit_Length=thmin;//Ein Min-Wert war bereits vorhanden 
            thmin=highduration;// Der neue Min- Wert ist <= dem bisherigen Minimum
            mchar=1;
            Flag1=1;// Zeiten können ausgewertet werden.           
        }
        else{
            thmin=highduration;// Der erste Min- Wert wird gespeichert.
            indexMin=Hpointer;//dazu der Index
        }
    }
    Hpointer++;
  }
}

void StoreLow(void){// Pausendauer speichern
if(Lpointer>=Hpointer) return;//zuerst muss ein High kommen!
Ltimes[Lpointer++]=(int16)lowduration;

if(lowduration>=tlmax) {
    tlmax=lowduration;// Überlange Pause ausschliessen (geschieht in main)
    if((Flag1==1)&&(tlmax>3*Dit_Length)&&(2*tlmin<tlmax)){
        Start=0;// Zeiten können ausgewertet werden. 
        Flag1=0;
    }
  }
    else if((lowduration<tlmin)&&(lowduration>tprell)) {
    tlmin=lowduration;    
  }
  tlkrit=(tlmax+tlmin)/2;
}

void ComputeFirstSigs(void){
  if(Start!=0) return;
  while(ReadPointer<Hpointer){
    cLength++;
    if(cLength<7) { 
        mchar= mchar<<1;
        if(Htimes[ReadPointer]>2*Dit_Length)  mchar++;    //DAA();//Zeichendauer auswerten                     
        //DIT();         
    } 
  //Pausendauer auswerten
    if(2*Ltimes[ReadPointer]>=3*tlmax){ //8*Dit_Length){//Wort- Ende
      decode(); 
      CharOut(' ');
    }
    else if(Ltimes[ReadPointer]>tlkrit) //4*Dit_Length)){// Buchstaben- Ende
      decode();
    
    ReadPointer++;
  }
   
   mchar=1;//neuer Startwert für Zeichenaufbau
   Start=2;//Auswertung beendet            
}

// **************************************************************************************************************

void GetSignal(){  // holt Samples von den Goertzel- Filtern
int32 helpL, helpH;
char  Flag1=0;
    while (Flag==0){// warten auf Input vom GoertzelM (Ablaufzeit)
        
         if(Counter2>=100){        
            GoertzelL=(P1*P1)+(P2*P2)-P1*P2*coeffL;
            P1=P2=0;
            GoertzelH=(R1*R1)+(R2*R2)-R1*R2*coeffH;
            R1=R2=0;
            Counter2=0;
            Flag1=0;
          }
         else if(Flag1==0){// nur einmal zu durchlaufen
            Flag1=1;
            helpL=GoertzelL/100000000;
            helpH=GoertzelH/100000000;
            helpLQuer= helpLQuer-(helpLQuer>>3)+ (helpL>>3);// gleitender Mittelwert
            helpHQuer= helpHQuer-(helpHQuer>>3)+ (helpH>>3);
            if(noiseCounter>=3){
                LED_2_0_Write(0xff);//LED's aus
                LED_4_3_Write(0xff);
            }
            else{
                if(helpHQuer>400) LED_2_0_Write(0);//20
                else LED_2_0_Write(0xff);
                if(helpLQuer>400) LED_4_3_Write(0);//20
                else LED_4_3_Write(0xff);
            }
         } 
      if(Flag3==1){// Wartezeit ausnutzen
            Flag3=0;
            Count3++;
            Msig=Msig-(Msig>>5)+(filtero>>5);//gleitender Mittelwert
            if(Count3>500){
                Count3=0;
                if(SigMax<Msig) {
                    SigMax=Msig;
                    StrengthCounter++;
                }
                else if(SigMin>Msig) {
                    SigMin=Msig;
                    StrengthCounter1++;
                }
                else {
                    SigMax=SigMax-(SigMax>>3);
                    SigMin=SigMin+(SigMin>>3);            
                }
                
                if((StrengthCounter>2)&&(StrengthCounter1>2)){
                    RelSig=SigMax/SigMin;// Skalierter Verhältniswert
                    StrengthCounter=0;
                    StrengthCounter1=0;
                }
            }
        }
    }
    // Auswertung des Goertzel- Hauptfilters:
    Flag=0;// neuen Abfrage- Zyklus einleiten
    GoertzelM=(Q1*Q1)+(Q2*Q2)-Q1*Q2*coeff;//Quadrat der Magnitude
    Q1=Q2=0;
    magnitude=GoertzelM/100000000;//1000000000 bei nn=150
  
    rd++;
   
    if (rd>20){
        rd=0;
        if((helpLQuer<20)||(helpHQuer<20))
            
        //  DAFC **************
        if(helpLQuer+helpHQuer>50){
            coeffneu=coeffM- (helpHQuer-helpLQuer)/(helpLQuer+helpHQuer)* 0.02; 
           // coeff=coeffneu;
           if((coeffneu<coeffLS)&&(coeffneu>coeffHS)) {
                coeff=coeffneu;// Auswertefilter neu einstellen
                
           }
         // if(filtero>4000){
         //     DataContr=1;
            //  sprintf(line0,"%5.0f",filtero);
            //  LCD_Position(0,0);
            //  LCD_PrintString(line0);
          }
          
           // LCD_Position(1,0);
           // sprintf(line0,"%1.4f",coeff); 
           // LCD_PrintString(line0); 
        }
        
 //   }
 /*  rc++;
    if(rc>50){
        rc=0;
       sprintf(line0,"%5f",filteri);
    LCD_Position(0,0);
    LCD_PrintString(line0);
       LCD_Position(2,0);// Testanzeige des Goertzel- Filters
        LCD_PrintString("                    ");
        sprintf(line0,"%4.0f",helpLQuer);
        LCD_Position(2,0);
        LCD_PrintString(line0);
        sprintf(line0,"%4.0f",help);
        LCD_Position(0,7);
        LCD_PrintString(line0);*/
       // sprintf(line0,"%4.0f",helpHQuer);
       // LCD_Position(2,15);
       // LCD_PrintString(line0);
  // }
       
 
 // magnitude=help;//GoertzelM;
 /* counter1++;
  if(counter1==50){
 //   Serial.print(magnitude); Serial.println();  //// here you can measure magnitude for setup..
    counter1=0;
  }*/
  /////////////////////////////////////////////////////////// 
  // here we will try to set the magnitude limit automatic //
  ///////////////////////////////////////////////////////////
  MagnQuer=MagnQuer-(MagnQuer>>4)+(magnitude>>4);
  if (magnitude > magnitudelimit_low){
    magnitudelimit = (magnitudelimit +((magnitude - magnitudelimit)/6));  //orig:6   moving average filter
  }
 
  if (magnitudelimit < magnitudelimit_low)
	magnitudelimit = magnitudelimit_low;
  
  ////////////////////////////////////
  // now we check for the magnitude //
  ////////////////////////////////////
  
  if(magnitude > magnitudelimit*0.6) {// just to have some space up 
     realstate = 1;
     if(noiseCounter>=3){
        LED_2_3_Write(0xff);//LED's aus   
     }
     else{
     LED_2_3_Write(0);//LED ein
     }
  }
  else {
    LED_2_3_Write(0xff);
    realstate = 0;
  }
  if (realstate != realstatebefore){// Signalwechsel
     filteredstate = realstate;//tatsächlicher Signalwechsel 

    realstatebefore = realstate;
 /////////////////////////////////////
 // we will turn on and off the LED //
 // and the speaker                 //
 /////////////////////////////////////
   if(noiseCounter>=3){
        LED_4_0_Write(0xff);//LED's aus
   }
   else{
       if(filteredstate == 1){ 
        starttimehigh = millis();
         LED_4_0_Write(0);// LED ein
    	// tone(audioOutPin,target_freq);
       }
       else{    
         starttimelow = millis();
         LED_4_0_Write(0xff);// LED aus
    	// noTone(audioOutPin);
       }
    }
  }
}


//////////////// ********************************************************************************************
// init setup //
////////////////


void setup() {

////////////////////////////////////
// The basic goertzel calculation //
////////////////////////////////////
  // Berechnungen für das Goertzel- Filter:
  float	omega;
  omega = (2.0 * PI * 800.0 / 16000.0);//  Hauptfilter
  coeff = 2.0 * cos(omega);
  coeffM=coeff;
  omega=2.0 * PI * 750.0/8000.0;//750 Hz,  Abtastfrequenz 16000 Hz Hilfsfilter unten
  coeffL=2.0 * cos(omega);
  omega=2.0 * PI * 750.0/16000.0;//750 Hz,  Abtastfrequenz 16000 Hz Untergrenze für Hauptfilter
  coeffLS=2.0 * cos(omega);
  omega=2.0 * PI * 850.0/16000.0;//850 Hz,  Abtastfrequenz 16000 Hz Obergrenze für Hauptfilter
  coeffHS=2.0 * cos(omega);
  
  omega=2.0 * PI * 850.0/8000.0;//850 Hz,  Abtastfrequenz 16000 Hz Hilfsfilter oben
  coeffH=2.0 * cos(omega);

 
change=1;
LCD_Start();
ADC_Start();
ADC_IRQ_Enable ();
ADC_StartConvert ();	
Filter_Start();
VDAC_Start();
Opamp_1_Start();
Counter_MilliSek_Start();
//Counter_Sek_Start();
//ISR_0_5_sek_StartEx(ISR_0_5);
CYGlobalIntEnable;// Enable the global interrupt
keypressed=0;
line=2;//line=1;
pos=0;
LCD_Position(line,pos);
count=0;
Hpointer=Lpointer=0;
thmax=tlmax=0;
thmin=tlmin=20000;// 20 sek
thquer=0;
Start=1;
stop=0;
mchar=1;
cLength=0;
Dit_Length=55;
SigMax=0;
SigMin=50000;
Msig=0;
StrengthCounter=0;
StrengthCounter1=0;
}
// *************************************************************************************************************
///////////////
// main loop //
///////////////
 void main() {
 setup();
    
 while(1){
  ///////////////////////////////////// 
  // The basic where we get the tone //
  /////////////////////////////////////
 
    GetSignal();//6,25 ms *************************************************************************
        
  ///////////////////////////////////////////////////// 
  // here we clean up the state with a noise blanker //
  /////////////////////////////////////////////////////
     if(mode==0){// Programm nach OZ1JHM
        
     ////////////////////////////////////////////////////////////
     // Then we do want to have some durations on high and low //
     ////////////////////////////////////////////////////////////
    
     if (filteredstate != filteredstatebefore){  //Signalwechsel erkannt  
       filteredstatebefore = filteredstate;
       
       if (filteredstate == 0){  // HIGH -> LOW
           highduration = starttimelow - starttimehigh;
           if(Start==2){
           stop=0;
           cLength++;
           if(cLength<=7) {
                mchar= mchar<<1;//bei Dit und DAA 
                if ((Dit_Length+Dit_Length)<highduration ) //&& (5*highduration >3* Dit_Length)){ /// 0.6 filter out false dits
                    mchar++;// DAA
                	
                 else   if((Start==2)&&(highduration>16)) 
                       Dit_Length=Dit_Length-(Dit_Length>>4)+(highduration>>4);// gleitender Mittelwert 
                                
               // bpm =6300/Dit_Length                                	   // bpm = (3 * bpm + (18900/highduration))/4;  //// the most precise we can do ;o)           
            }  else {
                 mchar=1;
                 cLength++;
                 CharOut('%');
                
               }
         }
           
            else if((highduration<600)&&(Start==1)) {//Start=1: Zeiten speichern
                StoreHigh();
             //   sprintf(line0,"%5d",(uint16)highduration);
             //   LCD_Position(0,9);
             //   LCD_PrintString(line0);
            
            }              
        }  
       
        else {//  Low-->High
    	   
    	   lowduration =starttimehigh - starttimelow;
           if((lowduration < 2000)&&(Start==1)){
                StoreLow();
           //    sprintf(line0,"%5d",(uint16)lowduration);// Hilfsanzeige
           //    LCD_Position(0,4);
           //    LCD_PrintString(line0);
           }           
       //LOW --> HIGH
       
     //  float lacktime = 1;
     //  if(wpm > 25)lacktime=1.0; ///  when high speeds we have to have a little more pause before new letter or new word 
     //  if(wpm > 30)lacktime=1.2;
     //  if(wpm > 35)lacktime=1.5;
       
 //      if ((lowduration > Dit_Length*2*lacktime) && (lowduration < Dit_Length*5*lacktime)){ // letter space
       if ((lowduration >= tlkrit)&&(Start==2) ){ // 4*Dit_Length letter space  3
         if(mchar!=1)
            decode();
    	//code1[0] = '\0';
    	//Serial.print("/");
       }
   //   else if (lowduration >= Dit_Length*5*lacktime){ // word space
       //else { // word space
       //decode();
    	//code1[0] = '\0';
    	//CharOut(" ");// ********************
    	//Serial.println();
      // }
   } 
  
  } else{
 
 //////////////////////////////
 // write if no more letters //
 //////////////////////////////
       if(Start==0){
             ComputeFirstSigs();
       }
       if ((Start==2)&&((millis() - starttimelow) >= (Dit_Length * 12)) && (stop == 0)&&(filteredstate == 0)){//Lange Pause
            if(mchar!=1){
                decode();
                CharOut(' ');
            }
            stop = 1;
           // Start=1;
           /* thmax=tlmax=0;
            thmin=tlmin=20000;// 20 sek
            thquer=0;
            indexMin=255;
            Dit_Length=37;
            
            Flag1=0;
            ReadPointer=Hpointer=Lpointer=0;
            indexMin=255;*/
        }
    }
    
    //sprintf(line0,"%5d",(uint16)bpm);
    LCD_Position(0,14);
    LCD_PrintString(line0);
    sprintf(line0,"%5d",(uint16)Dit_Length);
    LCD_Position(0,10);
    LCD_PrintString(line0);
      sprintf(line0,"%3d",RelSig);
        LCD_Position(0,0);
        LCD_PrintString(line0);
    
       /*   sprintf(line0,"%5ld",SigMax);
        LCD_Position(0,6);
        LCD_PrintString(line0);
    for(zei=0;zei<240;zei++){
    
        LCD_PutChar(zei);
        CyDelay(200);
       }*/
    
            
/*
 /////////////////////////////////////
 // we will turn on and off the LED //
 // and the speaker                 //
 /////////////////////////////////////
 
   if(filteredstate == HIGH){ 
     digitalWrite(ledPin, HIGH);
	 tone(audioOutPin,target_freq);
   }
   else{
     digitalWrite(ledPin, LOW);
	 noTone(audioOutPin);
   }*/
     
  
  
}  
 /*----------------------------------------------------------------------------------------------------*/

else if (mode==1){	

	
	if((realstate==1)){//Comparator auslesen: Taste gedrückt
		
	
	//Morsedecoder
		timerstart=millis();
		todo=1;
		while(millis()-timerstart<10){//Warten auf Timer 1 -  (alle 10 ms)
			time=millis();
			diff=time-timeold;// down- counter!!
			if(diff<0)diff=diff+1000;		
			if(diff>=20){
				timeold=time;
				continue;
			}
			if(phase==4){			
				decode();//Zeichen decodieren und ausgeben
				phase=0;				
			}	
			if(ende){
				ende=0;
				decode();
				phase=0;
			}
			if(todo)	{				
				/*lcd.setCursor(1, 0);	
				PrintChar((char)(Ditlength&255));
				Bpm=600/Ditlength;			
				lcd.setCursor(1, 7);				
				PrintChar(Bpm);				
				lcd.print("Bpm");*/
				todo=0;
			}											
		}
		sig=millis()-timerstart;//Abfrage Impulszähler
		
		if(sig>5){//Signalbewertung 5
			sign=1;
            //            digitalWrite(ledPin, HIGH);
			LED_2_0_Write(0);//LED ein			
		}else{
			sign=0;
			//digitalWrite(ledPin, LOW);
            LED_2_0_Write(0xff);//LED aus
		}
		
		//lcd.setCursor(0, 15);
		//PrintChar(phase);// Test
		
		switch(phase){
			
			case 0:{//Zeichenanfang suchen/ Pausendauer messen
				if(sign){
					if(prevstate==0){	//Signal Low --> High
						prevstate=1;
						tsig=0;
						//tprell=0;
						phase=1;//Ende der Pause
					}
				}
				else{
					prevstate=0;
					tpaus++;
					if(tpaus>tkrit){							
						LCD_Position(1, 14);
						LCD_PrintString("      ");//'tone'bzw. 'ditdit' löschen
					}
					if(tpaus==wpaus){
						we=1;//Wortende					
					}
				}
			break;
			}
			case 1:{//innerhalb des Zeichens			
				if(sign){
					tsig++;//Signaldauer messen
					//tprell++;
					//if(tprell>2) tprell=2; //Prellzeit abgelaufen
					if(tsig > tmax)	{
						tsig=0;
						err=1;//Fehler: Dauerton									
						LCD_Position(1, 14);
						LCD_PrintString(" tone ");
						break;//Phase 1 bleibt bestehen
					}
				}
				else{
					//if(tprell>=2){//Prellzeit ist abgelaufen						
						prevstate=0;
						if(err==0){
							//Signal High --> Low Ende Dit/Daa
							//Dit bzw. Daa erkennen und auswerten
							tpaus=0;
							if(start1==0){
								if(tsig>=tkrit) DAA();//Wir haben ein Daa
									else DIT();	
							} else	firstsig=tsig;
							phase=3;
							break;
						}
						else {
							err=0;
							tpaus=0;
							phase=0;
							}
					/*}
					else{
						tsig++;//Signal wird trotzdem weitergezählt
						//tprell++;
					}*/
				}
			break;
			}															
			case 3:
            {//Pausendauer messen				
				if(sign==0){
					tpaus++;
					if(tpaus> tmax){
						we=1;
						ende=1;//Ende der Sendung
						phase=0;
						break;
					}					
					if(tpaus==wpaus){
						we=1;//Wortende
						phase=0;// Zeichenende
						break;
					}
					if(tpaus>=chpaus){
						phase=4;// Zeichenende											
					}
				}
				else{
					prevstate=1;// **low--> high**, Ende der Pause bzw. Beginn erstes Dit/Daa
					// Es ist ein Dit bzw. Daa vorangegangen
					if(tpaus<tkrit) {// wir haben eine kleine Pause						
						if(start1)	{
							start1=0;
							Dit_Length=tpaus;//Synchronisieren: erste Pause...
							ReInit();//   ...gleich Ditlänge
							tsig=firstsig;//das erste Dit/Daa neu bewerten
							if(tsig>=tkrit) DAA();//Wir hatten ein Daa
								else DIT();	
						}	
						phase=1;//weiter im Zeichen
						break;
					}
					if(tpaus>=chpaus){
						phase=4;// Zeichenende											
					}
					tsig++;
					if(tsig > tmax)	{
						tsig=0;
						err=1;//Fehler: Dauerton									
						LCD_Position(14, 1);
						LCD_PrintString("tone ");
						break;//Phase 1 bleibt bestehen
					}
				}
			break;				
			}	
            
			default:{}							
		}
		if(we){
			we=0;
			LCD_PutChar(' ');// Wortende
			pos++;
			roll();// Testhilfe	
			phase=0;
		}	
			
      }
  }



 //////////////////////////////////
 // the end of main loop clean up//
 /////////////////////////////////
// updateinfolinelcd();
 
if(mode==1){
     LCD_Position(0,0);
     LCD_PrintString("Min ");
    // PrintChar(umin);
     LCD_PrintString("  Max ");
     //PrintChar(umax);
     LCD_PrintString("    ");
     LCD_Position(0,1);// Spalte, Zeile
     LCD_PrintString("Avg ");
     //PrintChar(avg);
     umin=512;
     umax=0;
     //CyDelay(250);  //wait 250ms
 }
 if(Button_15_3_Read()==1){//  Select schaltet die Menüs um.
   CyDelay(500);  //wait 500ms
   mode++;
   if(mode>maxMenu) {
     mode=0;
    /* LCD_Position(0,0);
     LCD_PrintString("                ");
     LCD_Position(0,1);
     LCD_PrintString("                ");*/
   } 
   if(mode==1){
        LCD_Position(0, 0);
        LCD_PrintString("                    ");
        LCD_PrintString(" Morse-Monitor");
    	start1=1;//neu synchronisieren
    	pos=0;//Ausgabeposition
    	Dit_Length=13;//Startwert
    	timeold=millis();
    	ReInit();
    	phase=0;
     }
   }
  }
}   
 


/* [] END OF FILE */
